<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:tpl="http://software.in2p3.fr/lavoisier/application.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/application.xsd"
                xmlns:xpath="xalan://fr.in2p3.lavoisier.template.preprocess.XPathAnalyser"
                exclude-result-prefixes="xalan tpl xpath">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>

    <xsl:template match="@depth"/>
    <xsl:template match="@*">
        <xsl:copy-of select="."/>
    </xsl:template>

    <xsl:template match="*">
        <xsl:variable name="ancestors" select="count(ancestor::*)"/>
        <xsl:copy>
            <xsl:choose>
                <xsl:when test="descendant-or-self::*[@depth >= count(ancestor::*) - $ancestors]">
                    <xsl:attribute name="future">true</xsl:attribute>
                    <xsl:apply-templates select="@*[local-name()!='if']"/>

                    <!-- split @if into @if/@if-on-future -->
                    <xsl:choose>
                        <xsl:when test="(self::tpl:element|self::tpl:element-ignore)/@if">
                            <xsl:variable name="if" select="xpath:splitIf(@if, false())"/>
                            <xsl:if test="$if">
                                <xsl:attribute name="if">
                                    <xsl:value-of select="$if"/>
                                </xsl:attribute>
                            </xsl:if>
                            <xsl:variable name="if-on-future" select="xpath:splitIf(@if, true())"/>
                            <xsl:if test="$if-on-future">
                                <xsl:attribute name="if-on-future">
                                    <xsl:value-of select="$if-on-future"/>
                                </xsl:attribute>
                            </xsl:if>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:apply-templates select="@if"/>
                        </xsl:otherwise>
                    </xsl:choose>

                    <!-- ignore @future on descendant nodes -->
                    <xsl:copy-of select="* | text() | comment()"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates select="@*"/>
                    <xsl:apply-templates/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>